//License: GNU
//
//
//
//    Jonti's AV Sender
//
//    Copyright (C) 2007  Jonti Olds
//
//
//
//    This program is free software: you can redistribute it and/or modify
//
//    it under the terms of the GNU General Public License as published by
//
//    the Free Software Foundation, either version 3 of the License, or
//
//    (at your option) any later version.
//
//
//
//    This program is distributed in the hope that it will be useful,
//
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//
//    GNU General Public License for more details.
//
//
//
//    You should have received a copy of the GNU General Public License
//
//    along with this program.  If not, see <http://www.gnu.org/licenses/>

//---------------------------------------------------------------------------

#ifndef InterleaverConvH
#define InterleaverConvH
//---------------------------------------------------------------------------
#include <vector>
#include <stdlib.h>

class TInterleaver
{
        struct IDelayLine
        {
                std::vector<int> delay;
                int ptr;
        };
public:
        TInterleaver();
        TInterleaver(int B, int M);
        void Init(int B, int M);
        int __fastcall DeInterleaveUpdate(int val);
        int __fastcall InterleaveUpdate(int val);
        int delaylineptr;
        void __fastcall InterLeaveBlock(int *Block);
        void __fastcall ResetInterleaverPtr();
        void __fastcall ResetDeInterleaverPtr();
private:
        std::vector<IDelayLine> Idelaylines;
        int B_g;
};
#endif


